package com.winterchen.config.redis;

import org.redisson.Redisson;
import org.redisson.api.RedissonClient;
import org.redisson.config.Config;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;

/**
 * redisson通用化配置
 **/
@Configuration
public class RedissonConfig {
    @Autowired
    private Environment env;

    @Value("${myredis.address}")
    private String address;
    @Value("${myredis.passord}")
    private String password;

    @Bean
    public RedissonClient redissonClient() {
        Config config = new Config();
        config.useSingleServer()
                .setAddress(address)
                .setPassword(password);
        RedissonClient client = Redisson.create(config);
        return client;
    }
}
