package com.winterchen.controller;

import com.alibaba.druid.support.spring.stat.SpringStatUtils;
import com.alibaba.excel.EasyExcel;
import com.winterchen.dao.UserMapper;
import com.winterchen.listener.BasicExcelListener;
import com.winterchen.model.UserDomain;
import com.winterchen.model.UserDomainExcelForm;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping(value = "/excel")
public class ExcelController {
    @Autowired
    private UserMapper userMapper;

    @PostMapping(value = "/import")
    public String importBasic(MultipartFile file) throws IOException {
        BasicExcelListener basicExcelListener = new BasicExcelListener(userMapper);
        EasyExcel.read(file.getInputStream(), UserDomainExcelForm.class, basicExcelListener).headRowNumber(1).sheet().doRead();
        return "导入成功";
    }

    @GetMapping(value = "/out")
    public void out(HttpServletResponse response) throws IOException {
        List<UserDomainExcelForm> data = new ArrayList();
        String name="zdd";
        for (int i = 0; i <100000 ; i++) {
            UserDomainExcelForm userDomainExcelForm=new UserDomainExcelForm();
            userDomainExcelForm.setUserName(name+i);
            userDomainExcelForm.setPassword(name+i);
            userDomainExcelForm.setPhone(name+i);
            data.add(userDomainExcelForm);
        }
        // 这里注意 有同学反应使用swagger 会导致各种问题，请直接用浏览器或者用postman
        response.setContentType("application/vnd.ms-excel");
        response.setCharacterEncoding("utf-8");
        // 这里URLEncoder.encode可以防止中文乱码 当然和easyexcel没有关系
        String fileName = URLEncoder.encode("测试", "UTF-8");
        response.setHeader("Content-disposition", "attachment;filename=" + fileName + ".xlsx");
        EasyExcel.write(response.getOutputStream(), UserDomainExcelForm.class).sheet("模板").doWrite(data);
    }
}
