package com.winterchen.listener;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.winterchen.dao.UserMapper;
import com.winterchen.model.UserDomainExcelForm;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

/*
 * 监听器批处理数据
 * */
public class BasicExcelListener extends AnalysisEventListener<UserDomainExcelForm> {


    private UserMapper userMapper;

    public BasicExcelListener() {
    }

    public BasicExcelListener(UserMapper userMapper) {
        this.userMapper = userMapper;
    }


    /**
     * 批处理阈值2000
     */
    private static final int BATCH_COUNT = 2000;

    List<UserDomainExcelForm> list = new ArrayList();

    List<UserDomainExcelForm> erroList = new ArrayList<>();


    @Override
    public void invoke(UserDomainExcelForm userDomain, AnalysisContext analysisContext) {
        //获取对应的行数
        int num = analysisContext.readRowHolder().getRowIndex();
        list.add(userDomain);
        if (list.size() >= BATCH_COUNT) {
            saveData();
            list.clear();
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {
        saveData();
        // log.info("所有数据解析完成！");

    }

    private void saveData(){
        try {
            //调用saveData()方法
            userMapper.saveData(list);
        } catch (Exception e) {
            e.getMessage();
            erroList.addAll(list);
            String templateFileName = "D:\\file"+ File.separator + "list.xlsx";
            EasyExcel.write(templateFileName, UserDomainExcelForm.class).sheet("模板").doWrite(erroList);
        }

    }
}
